<?php
namespace PME\Controllers\Servico;

use Zeedhi\Framework\Report\ReportService;
use Zeedhi\Framework\DTO;

class ConsPorServicoReport extends \Zeedhi\Framework\Controller\Report {

    protected $birtStrategy;
    protected $environment;

    public function __construct(ReportService $reportService, $birtStrategy, $environment) {
      $this->birtStrategy  = $birtStrategy;
      $this->environment   = $environment;

      parent::__construct($reportService);
    }

    protected $reportMapping = array (
      'PME00700' => 
        array (
            'strategy' => 'BIRT',
            'parameterMapping' => 
            array (
              "UNIDADEREPORT" => "P_CDFILIAL",
              "CONSUMO"       => "P_CONSUMO",
              "CDFILCENTPME"  => "P_CDFILCENTPME",
              "SERVICOREPORT" => "P_CDSERVFILI",
              "DTVALIDADE"    => "P_DTINIVALID",
              "DIASCONS"      => "P_IDTIPOCONS",
              "PRODUCTMASK"   => "P_PRODUCTMASK",
              "NRORG"         => "P_NRORG",
            )
        ),
        'PME00701' => 
        array (
            'strategy' => 'BIRT',
            'parameterMapping' => 
            array (
              "UNIDADEREPORT" => "P_CDFILIAL",
              "CONSUMO"       => "P_CONSUMO",
              "CDFILCENTPME"  => "P_CDFILCENTPME",
              "SERVICOREPORT" => "P_CDSERVFILI",
              "DTDE"          => "P_DTINI",
              "DTATE"         => "P_DTFIN",
              "IDTCONSSERV"   => "P_IDTCONSSERV",
              "PRODUCTMASK"   => "P_PRODUCTMASK",
              "NRORG"         => "P_NRORG",
            )
        )
    );
    
    public function beforeProcessReport(DTO\Request\Row $request, DTO\Response $response) {
      $row = $request->getRow();
      $nrorg = $this->environment->getNrOrg();
      
      $row['CONSUMO'] = implode('_', $row['TPCONSUMO']);
      
      if($row['CD_REPORT_CODE'] == 'PME00700'){
        if(in_array('T', $row['DIASCONSPADR'])) $row['DIASCONS'] = '1_2_3_4_5_6_7_8';
        else if(in_array('U', $row['DIASCONSPADR'])) {
          $key = array_search('U', $row['DIASCONSPADR']);
          unset($row['DIASCONSPADR'][$key]);
          $row['DIASCONS'] = '2_3_4_5_6_'.implode('_', $row['DIASCONSPADR']);
        } else $row['DIASCONS'] = implode('_', $row['DIASCONSPADR']); 
      }
      
      if($row['CD_REPORT_CODE'] == 'PME00701'){
        if($row['CONSUMO'] == 'F_P') $row['IDTCONSSERV'] = 'F_P_A';
        else $row['IDTCONSSERV'] = $row['CONSUMO'];
      } 
      
      $row['NRORG'] = $nrorg;
      
      $this->birtStrategy->setReportLocale($this->environment->getLanguage());
      $this->birtStrategy->setReportFormat(strtolower($row['reportFormat']));
    }
}