import { components } from '@zeedhi/vuetify';
import { Component, Prop } from 'vue-property-decorator';
import draggable from 'vuedraggable';
import { IDictionary } from '@zeedhi/core';
import { DragDropGrid as DragDropGridClass } from './common/DragDropGrid';

// eslint-disable-next-line prefer-destructuring
const ZdGridEditable = components.ZdGridEditable;

/**
 * DragDropGrid component
 */
@Component({
  components: { draggable },
})
export default class DragDropGrid extends ZdGridEditable {
  @Prop({ type: String, default: '' }) public orderColumnName!: string;

  public instance!: DragDropGridClass;

  public instanceType: typeof DragDropGridClass = DragDropGridClass;

  public dragOnMove(event: Event) {
    return this.instance.onDragMove(
      event,
      (event as IDictionary).draggedContext.element,
      this.$el as HTMLElement,
    );
  }

  public dragOnStart(event: Event) {
    this.instance.onDragStart(
      event,
      this.instance.datasource.data[(event as IDictionary).oldIndex],
      this.$el as HTMLElement,
    );
  }

  public dragOnEnd(event: Event) {
    this.instance.onDragEnd(
      event,
      this.instance.datasource.data[(event as IDictionary).newIndex],
      this.$el as HTMLElement,
    );
  }
}
